<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 418 $
 * $Id: CompanyFactory.class.php 418 2006-12-07 23:28:14Z ipso $
 * $Date: 2006-12-07 15:28:14 -0800 (Thu, 07 Dec 2006) $
 */
class CompanyFactory extends Factory {
	protected $table = 'company';
	protected $pk_sequence_name = 'company_id_seq'; //PK Sequence name

	protected $status_options = array(
										10 => 'ACTIVE',
										20 => 'HOLD',
										30 => 'CANCELLED'
									);

	protected $product_edition_options = array(
										10 => 'Standard',
										20 => 'Professional',
									);

	protected $country_options = array(
										'CA' => 'Canada',
										'US' => 'United States',
										'AF' => 'Afghanistan',
										'AL' => 'Albania',
										'DZ' => 'Algeria',
										'AS' => 'American Samoa',
										'AD' => 'Andorra',
										'AO' => 'Angola',
										'AI' => 'Anguilla',
										'AQ' => 'Antarctica',
										'AG' => 'Antigua and Barbuda',
										'AR' => 'Argentina',
										'AM' => 'Armenia',
										'AW' => 'Aruba',
										'AU' => 'Australia',
										'AT' => 'Austria',
										'AZ' => 'Azerbaijan',
										'BS' => 'Bahamas',
										'BH' => 'Bahrain',
										'BD' => 'Bangladesh',
										'BB' => 'Barbados',
										'BY' => 'Belarus',
										'BE' => 'Belgium',
										'BZ' => 'Belize',
										'BJ' => 'Benin',
										'BM' => 'Bermuda',
										'BT' => 'Bhutan',
										'BO' => 'Bolivia',
										'BA' => 'Bosnia and Herzegovina',
										'BW' => 'Botswana',
										'BV' => 'Bouvet Island',
										'BR' => 'Brazil',
										'IO' => 'British Indian Ocean Territory',
										'BN' => 'Brunei Darussalam',
										'BG' => 'Bulgaria',
										'BF' => 'Burkina Faso',
										'BI' => 'Burundi',
										'KH' => 'Cambodia',
										'CM' => 'Cameroon',
										'CV' => 'Cape Verde',
										'KY' => 'Cayman Islands',
										'CF' => 'Central African Republic',
										'TD' => 'Chad',
										'CL' => 'Chile',
										'CN' => 'China',
										'CX' => 'Christmas Island',
										'CC' => 'Cocos (Keeling) Islands',
										'CO' => 'Colombia',
										'KM' => 'Comoros',
										'CG' => 'Congo',
										'CD' => 'Congo, the Democratic Republic of',
										'CK' => 'Cook Islands',
										'CR' => 'Costa Rica',
										'CI' => 'Cote D\'Ivoire',
										'HR' => 'Croatia',
										'CU' => 'Cuba',
										'CY' => 'Cyprus',
										'CZ' => 'Czech Republic',
										'DK' => 'Denmark',
										'DJ' => 'Djibouti',
										'DM' => 'Dominica',
										'DO' => 'Dominican Republic',
										'EC' => 'Ecuador',
										'EG' => 'Egypt',
										'SV' => 'El Salvador',
										'GQ' => 'Equatorial Guinea',
										'ER' => 'Eritrea',
										'EE' => 'Estonia',
										'ET' => 'Ethiopia',
										'FK' => 'Falkland Islands (Malvinas)',
										'FO' => 'Faroe Islands',
										'FJ' => 'Fiji',
										'FI' => 'Finland',
										'FR' => 'France',
										'GF' => 'French Guiana',
										'PF' => 'French Polynesia',
										'TF' => 'French Southern Territories',
										'GA' => 'Gabon',
										'GM' => 'Gambia',
										'GE' => 'Georgia',
										'DE' => 'Germany',
										'GH' => 'Ghana',
										'GI' => 'Gibraltar',
										'GR' => 'Greece',
										'GL' => 'Greenland',
										'GD' => 'Grenada',
										'GP' => 'Guadeloupe',
										'GU' => 'Guam',
										'GT' => 'Guatemala',
										'GN' => 'Guinea',
										'GW' => 'Guinea-Bissau',
										'GY' => 'Guyana',
										'HT' => 'Haiti',
										'HM' => 'Heard Island and Mcdonald Islands',
										'VA' => 'Holy See (Vatican City State)',
										'HN' => 'Honduras',
										'HK' => 'Hong Kong',
										'HU' => 'Hungary',
										'IS' => 'Iceland',
										'IN' => 'India',
										'ID' => 'Indonesia',
										'IR' => 'Iran, Islamic Republic of',
										'IQ' => 'Iraq',
										'IE' => 'Ireland',
										'IL' => 'Israel',
										'IT' => 'Italy',
										'JM' => 'Jamaica',
										'JP' => 'Japan',
										'JO' => 'Jordan',
										'KZ' => 'Kazakhstan',
										'KE' => 'Kenya',
										'KI' => 'Kiribati',
										'KP' => 'Korea, Democratic People\'s Republic of',
										'KR' => 'Korea, Republic of',
										'KW' => 'Kuwait',
										'KG' => 'Kyrgyzstan',
										'LA' => 'Lao People\'s Democratic Republic',
										'LV' => 'Latvia',
										'LB' => 'Lebanon',
										'LS' => 'Lesotho',
										'LR' => 'Liberia',
										'LY' => 'Libyan Arab Jamahiriya',
										'LI' => 'Liechtenstein',
										'LT' => 'Lithuania',
										'LU' => 'Luxembourg',
										'MO' => 'Macao',
										'MK' => 'Macedonia, Former Yugoslav Republic of',
										'MG' => 'Madagascar',
										'MW' => 'Malawi',
										'MY' => 'Malaysia',
										'MV' => 'Maldives',
										'ML' => 'Mali',
										'MT' => 'Malta',
										'MH' => 'Marshall Islands',
										'MQ' => 'Martinique',
										'MR' => 'Mauritania',
										'MU' => 'Mauritius',
										'YT' => 'Mayotte',
										'MX' => 'Mexico',
										'FM' => 'Micronesia, Federated States of',
										'MD' => 'Moldova, Republic of',
										'MC' => 'Monaco',
										'MN' => 'Mongolia',
										'MS' => 'Montserrat',
										'MA' => 'Morocco',
										'MZ' => 'Mozambique',
										'MM' => 'Myanmar',
										'NA' => 'Namibia',
										'NR' => 'Nauru',
										'NP' => 'Nepal',
										'NL' => 'Netherlands',
										'AN' => 'Netherlands Antilles',
										'NC' => 'New Caledonia',
										'NZ' => 'New Zealand',
										'NI' => 'Nicaragua',
										'NE' => 'Niger',
										'NG' => 'Nigeria',
										'NU' => 'Niue',
										'NF' => 'Norfolk Island',
										'MP' => 'Northern Mariana Islands',
										'NO' => 'Norway',
										'OM' => 'Oman',
										'PK' => 'Pakistan',
										'PW' => 'Palau',
										'PS' => 'Palestinian Territory, Occupied',
										'PA' => 'Panama',
										'PG' => 'Papua New Guinea',
										'PY' => 'Paraguay',
										'PE' => 'Peru',
										'PH' => 'Philippines',
										'PN' => 'Pitcairn',
										'PL' => 'Poland',
										'PT' => 'Portugal',
										'PR' => 'Puerto Rico',
										'QA' => 'Qatar',
										'RE' => 'Reunion',
										'RO' => 'Romania',
										'RU' => 'Russian Federation',
										'RW' => 'Rwanda',
										'SH' => 'Saint Helena',
										'KN' => 'Saint Kitts and Nevis',
										'LC' => 'Saint Lucia',
										'PM' => 'Saint Pierre and Miquelon',
										'VC' => 'Saint Vincent, Grenadines',
										'WS' => 'Samoa',
										'SM' => 'San Marino',
										'ST' => 'Sao Tome and Principe',
										'SA' => 'Saudi Arabia',
										'SN' => 'Senegal',
										'CS' => 'Serbia and Montenegro',
										'SC' => 'Seychelles',
										'SL' => 'Sierra Leone',
										'SG' => 'Singapore',
										'SK' => 'Slovakia',
										'SI' => 'Slovenia',
										'SB' => 'Solomon Islands',
										'SO' => 'Somalia',
										'ZA' => 'South Africa',
										'GS' => 'South Georgia, South Sandwich Islands',
										'ES' => 'Spain',
										'LK' => 'Sri Lanka',
										'SD' => 'Sudan',
										'SR' => 'Suriname',
										'SJ' => 'Svalbard and Jan Mayen',
										'SZ' => 'Swaziland',
										'SE' => 'Sweden',
										'CH' => 'Switzerland',
										'SY' => 'Syrian Arab Republic',
										'TW' => 'Taiwan, Province of China',
										'TJ' => 'Tajikistan',
										'TZ' => 'Tanzania, United Republic of',
										'TH' => 'Thailand',
										'TL' => 'Timor-Leste',
										'TG' => 'Togo',
										'TK' => 'Tokelau',
										'TO' => 'Tonga',
										'TT' => 'Trinidad and Tobago',
										'TN' => 'Tunisia',
										'TR' => 'Turkey',
										'TM' => 'Turkmenistan',
										'TC' => 'Turks and Caicos Islands',
										'TV' => 'Tuvalu',
										'UG' => 'Uganda',
										'UA' => 'Ukraine',
										'AE' => 'United Arab Emirates',
										'GB' => 'United Kingdom',
										'UM' => 'United States Minor Outlying Islands',
										'UY' => 'Uruguay',
										'UZ' => 'Uzbekistan',
										'VU' => 'Vanuatu',
										'VE' => 'Venezuela',
										'VN' => 'Viet Nam',
										'VG' => 'Virgin Islands, British',
										'VI' => 'Virgin Islands, U.s.',
										'WF' => 'Wallis and Futuna',
										'EH' => 'Western Sahara',
										'YE' => 'Yemen',
										'ZM' => 'Zambia',
										'ZW' => 'Zimbabwe',
									);


	protected $province_options = array(
										'CA' => array(
														'BC' => 'British Columbia',
														'AB' => 'Alberta',
														'SK' => 'Saskatchewan',
														'MB' => 'Manitoba',
														'QC' => 'Quebec',
														'ON' => 'Ontario',
														'NF' => 'NewFoundLand',
														'NB' => 'New Brunswick',
														'NS' => 'Nova Scotia',
														'PE' => 'Prince Edward Island',
														'NT' => 'Northwest Territories',
														'YU' => 'Yukon',
														'NU' => 'Nunavut'
													),
										'US' => array(
													'AL' => 'Alabama',
													'AK' => 'Alaska',
													'AZ' => 'Arizona',
													'AR' => 'Arkansas',
													'CA' => 'California',
													'CO' => 'Colorado',
													'CT' => 'Connecticut',
													'DE' => 'Delaware',
													'DC' => 'D.C.',
													'FL' => 'Florida',
													'GA' => 'Georgia',
													'HI' => 'Hawaii',
													'ID' => 'Idaho',
													'IL' => 'Illinois',
													'IN' => 'Indiana',
													'IA' => 'Iowa',
													'KS' => 'Kansas',
													'KY' => 'Kentucky',
													'LA' => 'Louisiana',
													'ME' => 'Maine',
													'MD' => 'Maryland',
													'MA' => 'Massachusetts',
													'MI' => 'Michigan',
													'MN' => 'Minnesota',
													'MS' => 'Mississippi',
													'MO' => 'Missouri',
													'MT' => 'Montana',
													'NE' => 'Nebraska',
													'NV' => 'Nevada',
													'NH' => 'New Hampshire',
													'NM' => 'New Mexico',
													'NJ' => 'New Jersey',
													'NY' => 'New York',
													'NC' => 'North Carolina',
													'ND' => 'North Dakota',
													'OH' => 'Ohio',
													'OK' => 'Oklahoma',
													'OR' => 'Oregon',
													'PA' => 'Pennsylvania',
													'RI' => 'Rhode Island',
													'SC' => 'South Carolina',
													'SD' => 'South Dakota',
													'TN' => 'Tennessee',
													'TX' => 'Texas',
													'UT' => 'Utah',
													'VT' => 'Vermont',
													'VA' => 'Virginia',
													'WA' => 'Washington',
													'WV' => 'West Virginia',
													'WI' => 'Wisconsin',
													'WY' => 'Wyoming'
													),
										//Use '00' for 0, as I think there is a bug in the
										//AJAX library that appends function text if its just
										//a integer.
										'AF' => array( '00' => '--'),
										'AL' => array( '00' => '--'),
										'DZ' => array( '00' => '--'),
										'AS' => array( '00' => '--'),
										'AD' => array( '00' => '--'),
										'AO' => array( '00' => '--'),
										'AI' => array( '00' => '--'),
										'AQ' => array( '00' => '--'),
										'AG' => array( '00' => '--'),
										'AR' => array( '00' => '--'),
										'AM' => array( '00' => '--'),
										'AW' => array( '00' => '--'),
										'AU' => array(
														'ACT' => 'Australian Capital Territory',
														'NSW' => 'New South Wales',
														'NT' => 'Northern Territory',
														'QLD' => 'Queensland',
														'SA' => 'South Australia',
														'TAS' => 'Tasmania',
														'VIC' => 'Victoria',
														'WA' => 'Western Australia',
													),
										'AT' => array( '00' => '--'),
										'AZ' => array( '00' => '--'),
										'BS' => array( '00' => '--'),
										'BH' => array( '00' => '--'),
										'BD' => array( '00' => '--'),
										'BB' => array( '00' => '--'),
										'BY' => array( '00' => '--'),
										'BE' => array( '00' => '--'),
										'BZ' => array( '00' => '--'),
										'BJ' => array( '00' => '--'),
										'BM' => array( '00' => '--'),
										'BT' => array( '00' => '--'),
										'BO' => array( '00' => '--'),
										'BA' => array( '00' => '--'),
										'BW' => array( '00' => '--'),
										'BV' => array( '00' => '--'),
										'BR' => array( '00' => '--'),
										'IO' => array( '00' => '--'),
										'BN' => array( '00' => '--'),
										'BG' => array( '00' => '--'),
										'BF' => array( '00' => '--'),
										'BI' => array( '00' => '--'),
										'KH' => array( '00' => '--'),
										'CM' => array( '00' => '--'),
										'CV' => array( '00' => '--'),
										'KY' => array( '00' => '--'),
										'CF' => array( '00' => '--'),
										'TD' => array( '00' => '--'),
										'CL' => array( '00' => '--'),
										'CN' => array( '00' => '--'),
										'CX' => array( '00' => '--'),
										'CC' => array( '00' => '--'),
										'CO' => array( '00' => '--'),
										'KM' => array( '00' => '--'),
										'CG' => array( '00' => '--'),
										'CD' => array( '00' => '--'),
										'CK' => array( '00' => '--'),
										'CR' => array( '00' => '--'),
										'CI' => array( '00' => '--'),
										'HR' => array( '00' => '--'),
										'CU' => array( '00' => '--'),
										'CY' => array( '00' => '--'),
										'CZ' => array( '00' => '--'),
										'DK' => array( '00' => '--'),
										'DJ' => array( '00' => '--'),
										'DM' => array( '00' => '--'),
										'DO' => array( '00' => '--'),
										'EC' => array( '00' => '--'),
										'EG' => array( '00' => '--'),
										'SV' => array( '00' => '--'),
										'GQ' => array( '00' => '--'),
										'ER' => array( '00' => '--'),
										'EE' => array( '00' => '--'),
										'ET' => array( '00' => '--'),
										'FK' => array( '00' => '--'),
										'FO' => array( '00' => '--'),
										'FJ' => array( '00' => '--'),
										'FI' => array( '00' => '--'),
										'FR' => array( '00' => '--'),
										'GF' => array( '00' => '--'),
										'PF' => array( '00' => '--'),
										'TF' => array( '00' => '--'),
										'GA' => array( '00' => '--'),
										'GM' => array( '00' => '--'),
										'GE' => array( '00' => '--'),
										'DE' => array( '00' => '--'),
										'GH' => array( '00' => '--'),
										'GI' => array( '00' => '--'),
										'GR' => array( '00' => '--'),
										'GL' => array( '00' => '--'),
										'GD' => array( '00' => '--'),
										'GP' => array( '00' => '--'),
										'GU' => array( '00' => '--'),
										'GT' => array( '00' => '--'),
										'GN' => array( '00' => '--'),
										'GW' => array( '00' => '--'),
										'GY' => array( '00' => '--'),
										'HT' => array( '00' => '--'),
										'HM' => array( '00' => '--'),
										'VA' => array( '00' => '--'),
										'HN' => array( '00' => '--'),
										'HK' => array( '00' => '--'),
										'HU' => array( '00' => '--'),
										'IS' => array( '00' => '--'),
										'IN' => array( '00' => '--'),
										'ID' => array( '00' => '--'),
										'IR' => array( '00' => '--'),
										'IQ' => array( '00' => '--'),
										'IE' => array( '00' => '--'),
										'IL' => array( '00' => '--'),
										'IT' => array( '00' => '--'),
										'JM' => array( '00' => '--'),
										'JP' => array( '00' => '--'),
										'JO' => array( '00' => '--'),
										'KZ' => array( '00' => '--'),
										'KE' => array( '00' => '--'),
										'KI' => array( '00' => '--'),
										'KP' => array( '00' => '--'),
										'KR' => array( '00' => '--'),
										'KW' => array( '00' => '--'),
										'KG' => array( '00' => '--'),
										'LA' => array( '00' => '--'),
										'LV' => array( '00' => '--'),
										'LB' => array( '00' => '--'),
										'LS' => array( '00' => '--'),
										'LR' => array( '00' => '--'),
										'LY' => array( '00' => '--'),
										'LI' => array( '00' => '--'),
										'LT' => array( '00' => '--'),
										'LU' => array( '00' => '--'),
										'MO' => array( '00' => '--'),
										'MK' => array( '00' => '--'),
										'MG' => array( '00' => '--'),
										'MW' => array( '00' => '--'),
										'MY' => array( '00' => '--'),
										'MV' => array( '00' => '--'),
										'ML' => array( '00' => '--'),
										'MT' => array( '00' => '--'),
										'MH' => array( '00' => '--'),
										'MQ' => array( '00' => '--'),
										'MR' => array( '00' => '--'),
										'MU' => array( '00' => '--'),
										'YT' => array( '00' => '--'),
										'MX' => array( '00' => '--'),
										'FM' => array( '00' => '--'),
										'MD' => array( '00' => '--'),
										'MC' => array( '00' => '--'),
										'MN' => array( '00' => '--'),
										'MS' => array( '00' => '--'),
										'MA' => array( '00' => '--'),
										'MZ' => array( '00' => '--'),
										'MM' => array( '00' => '--'),
										'NA' => array( '00' => '--'),
										'NR' => array( '00' => '--'),
										'NP' => array( '00' => '--'),
										'NL' => array( '00' => '--'),
										'AN' => array( '00' => '--'),
										'NC' => array( '00' => '--'),
										'NZ' => array( '00' => '--'),
										'NI' => array( '00' => '--'),
										'NE' => array( '00' => '--'),
										'NG' => array( '00' => '--'),
										'NU' => array( '00' => '--'),
										'NF' => array( '00' => '--'),
										'MP' => array( '00' => '--'),
										'NO' => array( '00' => '--'),
										'OM' => array( '00' => '--'),
										'PK' => array( '00' => '--'),
										'PW' => array( '00' => '--'),
										'PS' => array( '00' => '--'),
										'PA' => array( '00' => '--'),
										'PG' => array( '00' => '--'),
										'PY' => array( '00' => '--'),
										'PE' => array( '00' => '--'),
										'PH' => array( '00' => '--'),
										'PN' => array( '00' => '--'),
										'PL' => array( '00' => '--'),
										'PT' => array( '00' => '--'),
										'PR' => array( '00' => '--'),
										'QA' => array( '00' => '--'),
										'RE' => array( '00' => '--'),
										'RO' => array( '00' => '--'),
										'RU' => array( '00' => '--'),
										'RW' => array( '00' => '--'),
										'SH' => array( '00' => '--'),
										'KN' => array( '00' => '--'),
										'LC' => array( '00' => '--'),
										'PM' => array( '00' => '--'),
										'VC' => array( '00' => '--'),
										'WS' => array( '00' => '--'),
										'SM' => array( '00' => '--'),
										'ST' => array( '00' => '--'),
										'SA' => array( '00' => '--'),
										'SN' => array( '00' => '--'),
										'CS' => array( '00' => '--'),
										'SC' => array( '00' => '--'),
										'SL' => array( '00' => '--'),
										'SG' => array( '00' => '--'),
										'SK' => array( '00' => '--'),
										'SI' => array( '00' => '--'),
										'SB' => array( '00' => '--'),
										'SO' => array( '00' => '--'),
										'ZA' => array( '00' => '--'),
										'GS' => array( '00' => '--'),
										'ES' => array( '00' => '--'),
										'LK' => array( '00' => '--'),
										'SD' => array( '00' => '--'),
										'SR' => array( '00' => '--'),
										'SJ' => array( '00' => '--'),
										'SZ' => array( '00' => '--'),
										'SE' => array( '00' => '--'),
										'CH' => array( '00' => '--'),
										'SY' => array( '00' => '--'),
										'TW' => array( '00' => '--'),
										'TJ' => array( '00' => '--'),
										'TZ' => array( '00' => '--'),
										'TH' => array( '00' => '--'),
										'TL' => array( '00' => '--'),
										'TG' => array( '00' => '--'),
										'TK' => array( '00' => '--'),
										'TO' => array( '00' => '--'),
										'TT' => array( '00' => '--'),
										'TN' => array( '00' => '--'),
										'TR' => array( '00' => '--'),
										'TM' => array( '00' => '--'),
										'TC' => array( '00' => '--'),
										'TV' => array( '00' => '--'),
										'UG' => array( '00' => '--'),
										'UA' => array( '00' => '--'),
										'AE' => array( '00' => '--'),
										'GB' => array( '00' => '--'),
										'UM' => array( '00' => '--'),
										'UY' => array( '00' => '--'),
										'UZ' => array( '00' => '--'),
										'VU' => array( '00' => '--'),
										'VE' => array( '00' => '--'),
										'VN' => array( '00' => '--'),
										'VG' => array( '00' => '--'),
										'VI' => array( '00' => '--'),
										'WF' => array( '00' => '--'),
										'EH' => array( '00' => '--'),
										'YE' => array( '00' => '--'),
										'ZM' => array( '00' => '--'),
										'ZW' => array( '00' => '--'),
										);

	protected $district_options = array(
										'US' => array(
													'NY' => array(
																'NYC' => 'New York City',
																'Yonkers' => 'Yonkers'
															),
													'IN' => array(
																'All' => 'All Counties'
															),
													'MD' => array(
																'All' => 'All Counties'
															),
													)
										);


	protected $parent_validator_msg = 'Parent Company is invalid';
	protected $parent_validator_label = 'parent';

	protected $status_validator_options_msg = 'Incorrect Status';
	protected $status_validator_label = 'status';

	protected $productedition_validator_options_msg = 'Incorrect Product Edition';
	protected $productedition_validator_label = 'product_edition';

	protected $name_validator_length_msg = 'Name is too short or too long';
	protected $name_validator_label = 'name';

	protected $shortname_validator_length_msg = 'Short name is too short or too long';
	protected $shortname_validator_label = 'short_name';

	protected $businessnumber_validator_length_msg = 'Business Number is too short or too long';
	protected $businessnumber_validator_label = 'business_number';

	protected $originatorid_validator_length_msg = 'Originator ID is too short or too long';
	protected $originatorid_validator_label = 'originator_id';

	protected $datacenterid_validator_length_msg = 'Data Center ID is too short or too long';
	protected $datacenterid_validator_label = 'data_center_id';

	protected $address_validator_regex = '/^[a-zA-Z0-9-_\.#\ ]{1,250}$/i';

	protected $address1_validator_regex_msg = 'Address1 contains invalid characters';
	protected $address1_validator_length_msg = 'Address1 is too short or too long';
	protected $address1_validator_label = 'address1';

	protected $address2_validator_regex_msg = 'Address2 contains invalid characters';
	protected $address2_validator_length_msg = 'Address2 is too short or too long';
	protected $address2_validator_label = 'address2';

	protected $city_validator_regex = '/^[a-zA-Z0-9-\.\ ]{1,250}$/i';
	protected $city_validator_regex_msg = 'City contains invalid characters';
	protected $city_validator_length_msg = 'City name is too short or too long';
	protected $city_validator_label = 'city';

	protected $province_validator_options_msg = 'Invalid Province/State';
	protected $province_validator_label = 'province';

	protected $country_validator_options_msg = 'Invalid Country';
	protected $country_validator_label = 'country';

	protected $postalcode_validator_regex_msg = 'Postal/ZIP Code contains invalid characters, or invalid format';
	protected $postalcode_validator_length_msg = 'Postal/ZIP Code is too short or too long';
	protected $postalcode_validator_label = 'postal_code';

	protected $workphone_validator_isphonenumber_msg = 'Work phone number is invalid';
	protected $workphone_validator_label = 'work_phone';

	protected $faxphone_validator_isphonenumber_msg = 'Fax phone number is invalid';
	protected $faxphone_validator_label = 'fax_phone';

	protected $user_validator_msg = 'Contact User is invalid';
	protected $admincontact_validator_label = 'admin_contact';
	protected $billingcontact_validator_label = 'billing_contact';
	protected $supportcontact_validator_label = 'support_contact';

	protected $over_time_flag_validator_options_msg = 'Incorrect Over Time Flag';
	protected $over_time_flag_validator_label = 'over_time_flag';

	protected $under_time_flag_validator_options_msg = 'Incorrect Under Time Flag';
	protected $under_time_flag_validator_label = 'under_time_flag';

	function getParent() {
		return $this->data['parent_id'];
	}
	function setParent($id) {
		$id = trim($id);

		$clf = new CompanyListFactory();

		if ( $id == 0
				OR $this->Validator->isResultSetWithRows(	$this->parent_validator_label,
															$clf->getByID($id),
															$this->parent_validator_msg
															) ) {
			$this->data['parent_id'] = $id;

			return TRUE;
		}

		return FALSE;
	}

	function getStatus() {
		if ( isset($this->data['status_id']) ) {
			return $this->data['status_id'];
		}

		return FALSE;
	}
	function setStatus($status) {
		$status = trim($status);

		$key = Option::getByValue($status, $this->getOptions('status') );
		if ($key !== FALSE) {
			$status = $key;
		}

		if ( $this->Validator->inArrayKey(	$this->status_validator_label,
											$status,
											$this->status_validator_options_msg,
											$this->getOptions('status')) ) {

			$this->data['status_id'] = $status;

			return FALSE;
		}

		return FALSE;
	}

	function getProductEdition() {
		if ( isset($this->data['product_edition_id']) ) {
			return $this->data['product_edition_id'];
		}

		return FALSE;
	}
	function setProductEdition($val) {
		$val = trim($val);

		$key = Option::getByValue($val, $this->getOptions('product_edition') );
		if ($key !== FALSE) {
			$val = $key;
		}

		if ( $this->Validator->inArrayKey(	$this->productedition_validator_label,
											$val,
											$this->productedition_validator_options_msg,
											$this->getOptions('product_edition')) ) {

			$this->data['product_edition_id'] = $val;

			return FALSE;
		}

		return FALSE;
	}

	function getName() {
		return $this->data['name'];
	}
	function setName($name) {
		$name = trim($name);

		if 	(	$this->Validator->isLength(		$this->name_validator_label,
												$name,
												$this->name_validator_length_msg,
												2,
												100) ) {

			$this->data['name'] = $name;

			return TRUE;
		}

		return FALSE;
	}

	function getBusinessNumber() {
		if ( isset($this->data['business_number']) ) {
			return $this->data['business_number'];
		}

		return FALSE;
	}
	function setBusinessNumber($val) {
		$val = trim($val);

		if 	(	$val == ''
				OR $this->Validator->isLength(		$this->businessnumber_validator_label,
												$val,
												$this->businessnumber_validator_length_msg,
												2,
												200) ) {

			$this->data['business_number'] = $val;

			return TRUE;
		}

		return FALSE;
	}

	function getOriginatorID() {
		if ( isset($this->data['originator_id']) ) {
			return $this->data['originator_id'];
		}

		return FALSE;
	}
	function setOriginatorID($val) {
		$val = trim($val);

		if 	(	$val == ''
				OR $this->Validator->isLength(	$this->originatorid_validator_label,
												$val,
												$this->originatorid_validator_length_msg,
												2,
												200) ) {

			//Typo in SQL file, go with it for now.
			$this->data['originator_id'] = $val;

			return TRUE;
		}

		return FALSE;
	}

	function getDataCenterID() {
		if ( isset($this->data['data_center_id']) ) {
			return $this->data['data_center_id'];
		}

		return FALSE;
	}
	function setDataCenterID($val) {
		$val = trim($val);

		if 	(	$val == ''
				OR $this->Validator->isLength(	$this->datacenterid_validator_label,
												$val,
												$this->datacenterid_validator_length_msg,
												2,
												200) ) {

			$this->data['data_center_id'] = $val;

			return TRUE;
		}

		return FALSE;
	}


	function getShortName() {
		if ( isset($this->data['short_name']) ) {
			return $this->data['short_name'];
		}

		return FALSE;
	}
	function setShortName($name) {
		$name = trim($name);

		if 	(	$this->Validator->isLength(		$this->shortname_validator_label,
												$name,
												$this->shortname_validator_length_msg,
												2,
												15) ) {

			$this->data['short_name'] = $name;

			return TRUE;
		}

		return FALSE;
	}

	function getAddress1() {
		if ( isset($this->data['address1']) ) {
			return $this->data['address1'];
		}

		return FALSE;
	}
	function setAddress1($address1) {
		$address1 = trim($address1);

		if 	(	$this->Validator->isRegEx(		$this->address1_validator_label,
												$address1,
												$this->address1_validator_regex_msg,
												$this->address_validator_regex)
				AND
					$this->Validator->isLength(		$this->address1_validator_label,
													$address1,
													$this->address1_validator_length_msg,
													2,
													250) ) {

			$this->data['address1'] = $address1;

			return TRUE;
		}

		return FALSE;
	}

	function getAddress2() {
		if ( isset($this->data['address2']) ) {
			return $this->data['address2'];
		}

		return FALSE;
	}
	function setAddress2($address2) {
		$address2 = trim($address2);

		if 	(	$address2 != NULL
				AND (
					$this->Validator->isRegEx(		$this->address2_validator_label,
													$address2,
													$this->address2_validator_regex_msg,
													$this->address_validator_regex)
				AND
					$this->Validator->isLength(		$this->address2_validator_label,
													$address2,
													$this->address2_validator_length_msg,
													2,
													250) ) ) {

			$this->data['address2'] = $address2;

			return TRUE;
		}

		return FALSE;

	}

	function getCity() {
		if ( isset($this->data['city']) ) {
			return $this->data['city'];
		}

		return FALSE;
	}
	function setCity($city) {
		$city = trim($city);

		if 	(	$this->Validator->isRegEx(		$this->city_validator_label,
												$city,
												$this->city_validator_regex_msg,
												$this->city_validator_regex)
				AND
					$this->Validator->isLength(		$this->city_validator_label,
													$city,
													$this->city_validator_length_msg,
													2,
													250) ) {

			$this->data['city'] = $city;

			return TRUE;
		}

		return FALSE;
	}

	function getCountry() {
		if ( isset($this->data['country']) ) {
			return $this->data['country'];
		}

		return FALSE;
	}
	function setCountry($country) {
		$country = trim($country);

		if ( $this->Validator->inArrayKey(		$this->country_validator_label,
												$country,
												$this->country_validator_options_msg,
												$this->getOptions('country') ) ) {

			$this->data['country'] = $country;

			return TRUE;
		}

		return FALSE;
	}

	function getProvince() {
		if ( isset($this->data['province']) ) {
			return $this->data['province'];
		}

		return FALSE;
	}
	function setProvince($province) {
		$province = trim($province);

		Debug::Text('Country: '. $this->getCountry() .' Province: '. $province, __FILE__, __LINE__, __METHOD__,10);

		$options_arr = $this->getOptions('province');
		if ( isset($options_arr[$this->getCountry()]) ) {
			$options = $options_arr[$this->getCountry()];
		} else {
			$options = array();
		}

		if ( $this->Validator->inArrayKey(		$this->province_validator_label,
												$province,
												$this->province_validator_options_msg,
												$options ) ) {

			$this->data['province'] = $province;

			return TRUE;
		}

		return FALSE;
	}

	function getPostalCode() {
		if ( isset($this->data['postal_code']) ) {
			return $this->data['postal_code'];
		}

		return FALSE;
	}
	function setPostalCode($postal_code) {
		$postal_code = strtoupper( $this->Validator->stripSpaces($postal_code) );

		if 	(
				$postal_code == ''
				OR
				(
				$this->Validator->isPostalCode(		$this->postalcode_validator_label,
													$postal_code,
													$this->postalcode_validator_regex_msg,
													$this->getCountry() )
				AND
					$this->Validator->isLength(		$this->postalcode_validator_label,
													$postal_code,
													$this->postalcode_validator_length_msg,
													1,
													10)
				)
				) {

			$this->data['postal_code'] = $postal_code;

			return TRUE;
		}

		return FALSE;
	}

	function getWorkPhone() {
		if ( isset($this->data['work_phone']) ) {
			return $this->data['work_phone'];
		}

		return FALSE;
	}
	function setWorkPhone($work_phone) {
		$work_phone = trim($work_phone);

		if 	(	$this->Validator->isPhoneNumber(		$this->workphone_validator_label,
														$work_phone,
														$this->workphone_validator_isphonenumber_msg) ) {

			$this->data['work_phone'] = $work_phone;

			return TRUE;
		}

		return FALSE;
	}

	function getFaxPhone() {
		if ( isset($this->data['fax_phone']) ) {
			return $this->data['fax_phone'];
		}

		return FALSE;
	}
	function setFaxPhone($fax_phone) {
		$fax_phone = trim($fax_phone);

		if 	(	$fax_phone == ''
				OR
				$this->Validator->isPhoneNumber(		$this->faxphone_validator_label,
														$fax_phone,
														$this->faxphone_validator_isphonenumber_msg) ) {

			$this->data['fax_phone'] = $fax_phone;

			return TRUE;
		}

		return FALSE;
	}

	function getAdminContact() {
		if ( isset($this->data['admin_contact']) ) {
			return $this->data['admin_contact'];
		}

		return FALSE;
	}
	function setAdminContact($id) {
		$id = trim($id);

		$ulf = new UserListFactory();

		if ( !empty($id)
				AND 	$this->Validator->isResultSetWithRows(	$this->admincontact_validator_label,
																$ulf->getByID($id),
																$this->user_validator_msg
																) ) {

			$this->data['admin_contact'] = $id;

			return TRUE;
		}

		return FALSE;

	}

	function getBillingContact() {
		if ( isset($this->data['billing_contact']) ) {
			return $this->data['billing_contact'];
		}

		return FALSE;
	}
	function setBillingContact($id) {
		$id = trim($id);

		$ulf = new UserListFactory();

		if ( !empty($id)
				AND $this->Validator->isResultSetWithRows(	$this->billingcontact_validator_label,
															$ulf->getByID($id),
															$this->user_validator_msg
															) ) {

			$this->data['billing_contact'] = $id;

			return TRUE;
		}

		return FALSE;
	}

	function getSupportContact() {
		if ( isset($this->data['support_contact']) ) {
			return $this->data['support_contact'];
		}

		return FALSE;
	}
	function setSupportContact($id) {
		$id = trim($id);

		$ulf = new UserListFactory();

		if ( !empty($id)
				AND $this->Validator->isResultSetWithRows(	$this->supportcontact_validator_label,
															$ulf->getByID($id),
															$this->user_validator_msg
															) ) {

			$this->data['support_contact'] = $id;

			return TRUE;
		}

		return FALSE;
	}

	//Send company data to TimeTrex server so auto update notifications are correct
	//based on geographical region.
	//This shouldn't be called unless the user requests auto update notification.
	function remoteSave() {
		$ttsc = new TimeTrexSoapClient();

		if ( ( isProfessionalEditionAvailable() == TRUE OR $ttsc->isUpdateNotifyEnabled() == TRUE )
				AND PRODUCTION == TRUE
				AND DEMO_MODE == FALSE ) {
			$ttsc->sendCompanyData( $this->getId() );
			$ttsc->sendCompanyVersionData( $this->getId() );

			return TRUE;
		}

		return FALSE;
	}

	function postSave() {
		$this->removeCache( $this->getId() );

		$this->remoteSave();

		return TRUE;
	}

	function addLog( $log_action ) {
		return TTLog::addEntry( $this->getId(), $log_action, 'Company Information' , NULL, $this->getTable() );
	}

}
?>
