<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 449 $
 * $Id: EditClientPayment.php 449 2006-12-19 19:07:54Z ipso $
 * $Date: 2006-12-19 11:07:54 -0800 (Tue, 19 Dec 2006) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

if ( !$permission->Check('client_payment','enabled')
		OR !( $permission->Check('client_payment','edit') OR $permission->Check('client_payment','edit_own') ) ) {

	$permission->Redirect( FALSE ); //Redirect

}

$title = 'Edit Client Payment Method';
$smarty->assign('title', $title);
BreadCrumb::setCrumb($title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'id',
												'client_id',
												'data',
												) ) );
if ( isset($client_id) ) {
	$data['client_id'] = $client_id;
}

$cpf = new ClientPaymentFactory();
$action = strtolower($action);
switch ($action) {
	case 'submit':
		//Debug::setVerbosity(11);
		Debug::Text('Submit!', __FILE__, __LINE__, __METHOD__,10);

		$cpf->setId($data['id']);
		$cpf->setClient( $data['client_id'] );
		$cpf->setStatus($data['status_id']);
		$cpf->setType($data['type_id']);
		if ( isset($data['default']) ) {
			$cpf->setDefault(TRUE);
		} else {
			$cpf->setDefault(FALSE);
		}

		if ($data['type_id'] == 30 ) {
			$cpf->setCreditCardType($data['cc_type_id']);
			$cpf->setCreditCardName($data['cc_name']);
			$cpf->setCreditCardNumber($data['cc_number']);
			$cpf->setCreditCardCheck($data['cc_check']);
			$cpf->setCreditCardExpire( TTDate::getTimeStampFromSmarty('cc_expire_', $data) );
			//$cpf->setCreditCardExpire($data['cc_expire']);
			$cpf->setCreditCardBankPhone($data['cc_bank_phone']);
		} elseif ($data['type_id'] == 40) {
			$cpf->setInstitution($data['institution']);
			$cpf->setTransit($data['transit']);
			$cpf->setAccount($data['account']);
		}

		$cpf->setNote($data['note']);

		if ( $cpf->isValid() ) {
			$cpf->Save();

			Redirect::Page( URLBuilder::getURL( array('client_id' => $data['client_id'] ), 'ClientPaymentList.php') );

			break;
		}
	default:
		if ( isset($id) AND $action != 'submit') {
			unset($data);

			Debug::Text('Client ID: '. $id, __FILE__, __LINE__, __METHOD__,10);
			$cplf = new ClientPaymentListFactory();

			//$uwlf->GetByUserIdAndCompanyId($current_user->getId(), $current_company->getId() );
			$cplf->getByIdAndCompanyId($id, $current_company->getId() );

			foreach ($cplf as $cp_obj) {
				if ( $permission->Check('client_payment','view_credit_card') == TRUE ) {
					$cc_number = $cp_obj->getCreditCardNumber();
				} else {
					$cc_number = $cp_obj->getSecureCreditCardNumber();
				}
				
				$data = array(
									'id' => $cp_obj->getId(),
									'client_id' => $cp_obj->getClient(),
									'status_id' => $cp_obj->getStatus(),
									'type_id' => $cp_obj->getType(),
									'default' => $cp_obj->getDefault(),

									'cc_type_id' => $cp_obj->getCreditCardType(),
									'cc_name' => $cp_obj->getCreditCardName(),
									'cc_number' => $cc_number,
									'cc_expire' => $cp_obj->getCreditCardExpire(),
									'cc_check' => $cp_obj->getCreditCardCheck(),
									'cc_bank_phone' => $cp_obj->getCreditCardBankPhone(),

									'institution' => $cp_obj->getInstitution(),
									'transit' => $cp_obj->getTransit(),
									'account' => $cp_obj->getAccount(),

									'note' => $cp_obj->getNote(),

									'created_date' => $cp_obj->getCreatedDate(),
									'created_by' => $cp_obj->getCreatedBy(),
									'updated_date' => $cp_obj->getUpdatedDate(),
									'updated_by' => $cp_obj->getUpdatedBy(),
									'deleted_date' => $cp_obj->getDeletedDate(),
									'deleted_by' => $cp_obj->getDeletedBy()
								);
				unset($cc_number);
			}
		}

		$data['status_options'] = $cpf->getOptions('status');
		$data['type_options'] = $cpf->getOptions('type');
		$data['credit_card_type_options'] = $cpf->getOptions('credit_card_type');

		$smarty->assign_by_ref('data', $data);
		$smarty->assign_by_ref('client_id', $client_id);

		break;
}

$smarty->assign_by_ref('cpf', $cpf);

$smarty->display('client/EditClientPayment.tpl');
?>