<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 417 $
 * $Id: EditPremiumPolicy.php 417 2006-12-06 22:58:53Z ipso $
 * $Date: 2006-12-06 14:58:53 -0800 (Wed, 06 Dec 2006) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

if ( !$permission->Check('premium_policy','enabled')
		OR !( $permission->Check('premium_policy','edit') OR $permission->Check('premium_policy','edit_own') ) ) {

	$permission->Redirect( FALSE ); //Redirect
}

$title = 'Edit Premium Policy';
$smarty->assign('title', $title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'id',
												'data'
												) ) );

if ( isset($data)) {
	if ( $data['start_date'] != '' ) {
		$data['start_date'] = TTDate::parseDateTime( $data['start_date'] );
	}
	if ( $data['end_date'] != '' ) {
		$data['end_date'] = TTDate::parseDateTime( $data['end_date'] );
	}
	if ( $data['start_time'] != '' ) {
		$data['start_time'] = TTDate::parseDateTime( $data['start_time'] );
	}
	if ( $data['end_time'] != '' ) {
		$data['end_time'] = TTDate::parseDateTime( $data['end_time'] );
	}
}

$ppf = new PremiumPolicyFactory();

$action = strtolower($action);
switch ($action) {
	case 'submit':
		//Debug::setVerbosity(11);
		Debug::Text('Submit!', __FILE__, __LINE__, __METHOD__,10);

		$ppf->setId( $data['id'] );
		$ppf->setCompany( $current_company->getId() );
		$ppf->setName( $data['name'] );
		$ppf->setType( $data['type_id'] );
		$ppf->setPayType( $data['pay_type_id'] );
		//$ppf->setLevel( $data['level'] );

		$ppf->setStartDate( $data['start_date'] );
		$ppf->setEndDate( $data['end_date'] );

		$ppf->setStartTime( $data['start_time'] );
		$ppf->setEndTime( $data['end_time'] );

		if ( isset($data['mon']) ) {
			$ppf->setMon( TRUE );
		} else {
			$ppf->setMon( FALSE );
		}

		if ( isset($data['tue']) ) {
			$ppf->setTue( TRUE );
		} else {
			$ppf->setTue( FALSE );
		}

		if ( isset($data['wed']) ) {
			$ppf->setWed( TRUE );
		} else {
			$ppf->setWed( FALSE );
		}

		if ( isset($data['thu']) ) {
			$ppf->setThu( TRUE );
		} else {
			$ppf->setThu( FALSE );
		}

		if ( isset($data['fri']) ) {
			$ppf->setFri( TRUE );
		} else {
			$ppf->setFri( FALSE );
		}

		if ( isset($data['sat']) ) {
			$ppf->setSat( TRUE );
		} else {
			$ppf->setSat( FALSE );
		}

		if ( isset($data['sun']) ) {
			$ppf->setSun( TRUE );
		} else {
			$ppf->setSun( FALSE );
		}

		$ppf->setRate( $data['rate'] );
		$ppf->setPayStubEntryAccountId( $data['pay_stub_entry_account_id'] );
		//$otpf->setAccrualRate( $data['accrual_rate'] );

		if ( $ppf->isValid() ) {
			$ppf->Save();

			Redirect::Page( URLBuilder::getURL( NULL, 'PremiumPolicyList.php') );

			break;
		}

	default:
		if ( isset($id) ) {
			BreadCrumb::setCrumb($title);

			$pplf = new PremiumPolicyListFactory();
			$pplf->getById($id);

			foreach ($pplf as $pp_obj) {
				//Debug::Arr($station,'Department', __FILE__, __LINE__, __METHOD__,10);

				$data = array(
									'id' => $pp_obj->getId(),
									'name' => $pp_obj->getName(),
									'type_id' => $pp_obj->getType(),
									'pay_type_id' => $pp_obj->getPayType(),
									//'level' => $pp_obj->getLevel(),

									'start_date' => $pp_obj->getStartDate(),
									'end_date' => $pp_obj->getEndDate(),

									'start_time' => $pp_obj->getStartTime(),
									'end_time' => $pp_obj->getEndTime(),

									'sun' => $pp_obj->getSun(),
									'mon' => $pp_obj->getMon(),
									'tue' => $pp_obj->getTue(),
									'wed' => $pp_obj->getWed(),
									'thu' => $pp_obj->getThu(),
									'fri' => $pp_obj->getFri(),
									'sat' => $pp_obj->getSat(),

									'rate' => $pp_obj->getRate(),

									'accrual_rate' => $pp_obj->getAccrualRate(),
									'accrual_policy_id' => $pp_obj->getAccrualPolicyID(),
									'pay_stub_entry_account_id' => $pp_obj->getPayStubEntryAccountId(),

									'created_date' => $pp_obj->getCreatedDate(),
									'created_by' => $pp_obj->getCreatedBy(),
									'updated_date' => $pp_obj->getUpdatedDate(),
									'updated_by' => $pp_obj->getUpdatedBy(),
									'deleted_date' => $pp_obj->getDeletedDate(),
									'deleted_by' => $pp_obj->getDeletedBy()
								);
			}
		} elseif ( $action != 'submit') {
			$data = array(
								'start_time' => TTDate::strtotime('01-Jan-05 00:00'),
								'end_time' => TTDate::strtotime('01-Jan-05 23:59'),
								'rate' => '1.00',
								'accrual_rate' => '1.00' );
		}

		//$aplf = new AccrualPolicyListFactory();
		//$accrual_options = $aplf->getByCompanyIDArray( $current_company->getId(), TRUE );
		$psealf = new PayStubEntryAccountListFactory();
		$pay_stub_entry_options = $psealf->getByCompanyIdAndStatusIdAndTypeIdArray( $current_company->getId(), 10, array(10) );

		//Select box options;
		$data['type_options'] = $ppf->getOptions('type');
		$data['pay_type_options'] = $ppf->getOptions('pay_type');
		//$data['level_options'] = $ppf->getOptions('level');
		$data['pay_stub_entry_options'] = $pay_stub_entry_options;

		//$data['accrual_options'] = $accrual_options;

		$smarty->assign_by_ref('data', $data);

		break;
}

$smarty->assign_by_ref('ppf', $ppf);

$smarty->display('policy/EditPremiumPolicy.tpl');
?>